﻿//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// https://www.alldaq.com
//
// Purpose:
//       This file is part of the Interrupt project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------

using System.Globalization;

namespace Interrupt.Utility
{
    public static class InputValidation
    {
        public static string ValidateHexValue(string textValue, out uint hexValue)
        {
            hexValue = 0;
            string msg = string.Empty;
            if (string.IsNullOrEmpty(textValue))
            {
                msg = "Enter a valid number";
            }
            else if (!uint.TryParse(textValue, NumberStyles.AllowHexSpecifier, CultureInfo.InvariantCulture, out hexValue))
            {
                msg = "The entered text \"" + textValue + "\" is not a valid number";
            }
            return msg;
        }
    }
}
