﻿//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// https://www.alldaq.com
//
// Purpose:
//       This file is part of the Interrupt project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------


namespace Interrupt.ViewModels
{
    public class BitEdgeIndicatorItemViewModel : ViewModelBase
    {
        public BitEdgeIndicatorItemViewModel(int bitNumber)
        {
            BitNumber = bitNumber.ToString();
        }

        public string BitNumber { get; }


        private bool _risingEdge;
        public bool RisingEdge
        {
            get { return _risingEdge; }
            set
            {
                if (_risingEdge != value)
                {
                    _risingEdge = value;
                    NotifyPropertyChanged(nameof(RisingEdge));
                }
            }
        }

        private bool _fallingEdge;
        public bool FallingEdge
        {
            get { return _fallingEdge; }
            set
            {
                if (_fallingEdge != value)
                {
                    _fallingEdge = value;
                    NotifyPropertyChanged(nameof(FallingEdge));
                }
            }
        }
    }
}
