﻿//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// https://www.alldaq.com
//
// Purpose:
//       This file is part of the WriteBufferAO project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------

using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using WriteBufferAO.ViewModels;

namespace WriteBufferAO
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = new MainViewModel();
        }

        private void BtnInfo_Click(object sender, RoutedEventArgs e)
        {
            AboutBox aboutBox = new AboutBox(this);
            aboutBox.ShowDialog();
        }

        private void TextBox_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (sender is TextBox txtBox)
            {
                TextBoxScrollToEnd(txtBox);
            }
        }

        private void TextBoxScrollToEnd(TextBox txtBox)
        {
            // https://stackoverflow.com/questions/8938775/multiline-textbox-with-automatic-vertical-scroll
            var oldFocusedElement = FocusManager.GetFocusedElement(this);
            txtBox.Focus();
            txtBox.CaretIndex = txtBox.Text.Length;
            txtBox.ScrollToEnd();
            FocusManager.SetFocusedElement(this, oldFocusedElement);
        }
    }
}
