﻿//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// http://www.alldaq.com
//
// Purpose:
//       This file is part of the WriteBufferAO project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------

using System;
using WriteBufferAO.Utility;

namespace WriteBufferAO.Models
{
    public class SineWaveGenerator : ISignalGenerator
    {
        public string GeneratorIcon
        {
            get
            {
                return "/WriteBufferAO;component/Images/signalSine.png";
            }
        }

        public string GeneratorName
        {
            get
            {
                return "Sine wave";
            }
        }

        public double GetValue(double cycleTime, double signalMinimum, double signalMaximum)
        {
            return (signalMaximum + signalMinimum) / 2.0 + (signalMaximum - signalMinimum) / 2.0 * Math.Sin(AdqCommon.TwoPI * cycleTime);
        }
    }
}
