﻿//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// http://www.alldaq.com
//
// Purpose:
//       This file is part of the WriteBufferAO project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------


namespace WriteBufferAO.Models
{
    public class TriangleWaveGenerator : ISignalGenerator
    {
        public string GeneratorIcon
        {
            get
            {
                return "/WriteBufferAO;component/Images/signalTriangle.png";
            }
        }

        public string GeneratorName
        {
            get
            {
                return "Triangle";
            }
        }

        public double GetValue(double cycleTime, double signalMinimum, double signalMaximum)
        {
            double value;
            if (cycleTime <= 0.5)
            {
                value = signalMinimum + 2.0 * (signalMaximum - signalMinimum) * cycleTime;
            }
            else
            {
                value = signalMaximum - 2.0 * (signalMaximum - signalMinimum) * (cycleTime - 0.5);
            }
            return value;
        }
    }
}
