﻿'-----------------------------------------------------------------------------
' ALLDAQ, a division of ALLNET GmbH
' https://www.alldaq.com
'
' Purpose:
'       This file Is part of the FINRead project of the ALLDAQ-SDK.  
'       It shows the usage of the API functions to access
'       ALLDAQ Data Acquisition Boards
' 
'-----------------------------------------------------------------------------

Class MainWindow
    Private _mainViewModel As MainViewModel

    Sub New()
        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        AddHandler Loaded, AddressOf OnLoaded
    End Sub

    Private Sub OnLoaded(sender As Object, e As RoutedEventArgs)
        _mainViewModel = New MainViewModel()
        DataContext = _mainViewModel
        AddHandler Closing, AddressOf _mainViewModel.OnWindowClosing
        _mainViewModel.Init()
    End Sub

    Private Sub BtnInfo_Click(sender As Object, e As RoutedEventArgs)
        Dim aboutBox = New AboutBox(Me)
        aboutBox.ShowDialog()
    End Sub

    Private Sub TextBox_TextChanged(sender As Object, e As TextChangedEventArgs)
        TextBoxInfo.ScrollToEnd()
    End Sub
End Class
