﻿'-----------------------------------------------------------------------------
' ALLDAQ, a division of ALLNET GmbH
' https://www.alldaq.com
'
' Purpose:
'       This file Is part of the WriteBufferAO project of the ALLDAQ-SDK.  
'       It shows the usage of the API functions to access
'       ALLDAQ Data Acquisition Boards
' 
'-----------------------------------------------------------------------------

Public Class SineModSquareWaveGenerator
    Implements ISignalGenerator

    Public ReadOnly Property GeneratorIcon As String Implements ISignalGenerator.GeneratorIcon
        Get
            Return "/WriteBufferAO;component/Images/signalSinusoidal.png"
        End Get
    End Property

    Public ReadOnly Property GeneratorName As String Implements ISignalGenerator.GeneratorName
        Get
            Return "Sine modulated square"
        End Get
    End Property

    Public Function GetValue(cycleTime As Double, signalMinimum As Double, signalMaximum As Double) As Double Implements ISignalGenerator.GetValue
        Dim offset As Double = (signalMaximum + signalMinimum) / 2.0
        Dim value As Double = (signalMaximum - signalMinimum) / 2.0 * Math.Sin(AdqCommon.TwoPI * cycleTime)

        If cycleTime Mod 0.1 > 0.05 Then
            Return offset + value
        Else
            Return offset - value
        End If
    End Function
End Class
