#include <windows.h>

#include <stdio.h>
#include <stdlib.h>

#include <tchar.h>

#include <conio.h>

#include "..\\adqDevice.h"

#ifdef WIN64

#pragma comment(lib, "..\\adqDevice_64.lib")

#else

#pragma comment(lib, "..\\adqDevice.lib")

#endif

int _tmain(int argc, _TCHAR* argv[])
{
   // Increase the size of the console buffer
    
    HANDLE  h_console = GetStdHandle(STD_OUTPUT_HANDLE);

    COORD coord;

    coord.X = 160;
    
    coord.Y = 9999;
    
    SetConsoleScreenBufferSize(h_console, coord);

    bool b_terminate = false;

    bool b_remote = false;

    wchar_t wsz_remote_name_or_IP_address[128];

    while(true)
    {
        printf( "1. Open local\n"
                "2. Open remote\n"
                "\n"
                "Your choice: 1 or 2 (RETURN to exit): ");

        char sz_response[8];

        gets_s(&sz_response[0], 8);

        printf("\n\n");

        if(sz_response[0] == 0)
        {
            b_terminate = true;
            
            break;
        }

        unsigned int ui_choice = 0;

        if( sscanf_s(&sz_response[0], "%u", &ui_choice) != 1)
        {
            continue;
        }

        if(ui_choice == 1)
        {
            break;
        }

        if(ui_choice == 2)
        {
            b_remote = true;

            printf("Name or IP-Address (RETURN to exit): ");

            _getws_s(&wsz_remote_name_or_IP_address[0], 128);

            printf("\n\n");

            if( wsz_remote_name_or_IP_address[0] == (wchar_t)0 )
            {
                b_terminate = true;
            }

            break;
        }
    }

    if(b_terminate)
    {
        printf("Press any key to exit.\n");

        _getch();

        exit(-1);
    }

    unsigned int ui_adq_error;
    
    if(b_remote)
    {
        wchar_t* pwc_user_name_or_address[2] = {&wsz_remote_name_or_IP_address[0],
                                                NULL                                };

        ui_adq_error = adqOpenEx(pwc_user_name_or_address);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            printf("adqOpenEx returned 0x%08X\n\n", ui_adq_error);

            printf("Press any key to exit.\n");

            _getch();

            exit(-1);
        }
    }
    else
    {
        ui_adq_error = adqOpen();

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            printf("adqOpen returned 0x%08X\n\n", ui_adq_error);

            printf("Press any key to exit.\n");

            _getch();

            exit(-1);
        }
    }

    unsigned int ui_number_of_boards;
    
    ui_adq_error = adqGetNumberOfBoards(ui_number_of_boards);

    if(ui_adq_error != ADQ_ERROR_NONE)
    {
        printf("adqGetNumberOfBoards returned 0x%08X\n\n", ui_adq_error);

        printf("Press any key to exit.\n");

        adqClose();

        _getch();

        exit(-1);
    }

    if(ui_number_of_boards == 0)
    {
        printf("No ADQ boards found!\n\n");

        printf("Press any key to exit.\n");

        adqClose();

        _getch();

        exit(-1);
    }

    printf("%3u ADQ Boards found\n\n", ui_number_of_boards);

    char sz_response[8];

    while(TRUE)
    {

        int b_terminate = 0;

        int b_reset_module = 0;

        while(TRUE)
        {
            printf("1. ResetBoard\n"
                   "2. ResetModule\n\n");

            printf("\n");

            printf("Your choice 1 or 2 (RETURN to exit): ");

            gets_s(&sz_response[0], 8);

            printf("\n\n");

            if(sz_response[0] == 0)
            {
                b_terminate = 1;
                
                break;
            }
            else if(sz_response[0] == '1')
            {
                break;
            }
            else if(sz_response[0] == '2')
            {
               b_reset_module = 1;
                
                break;
            }
        }

        if(b_terminate != 0)
        {
            break;
        }

        unsigned int ui_board_index = 0;

        while(TRUE)
        {
            printf("\n");

            printf("Please choose the board index 0 - %d (RETURN to exit): ",
                   ui_number_of_boards - 1                                  );

            gets_s(&sz_response[0], 8);

            printf("\n\n");

            if(sz_response[0] == 0)
            {
                b_terminate = 1;
                
                break;
            }

            if( sscanf_s(&sz_response[0], "%u", &ui_board_index) != 1 )
            {
                continue;
            }

            if( (0 <= ui_board_index)&&(ui_board_index < ui_number_of_boards) )
            {
                break;
            }
        }

        if(b_terminate != 0)
        {
            break;
        }

        unsigned int ui_module_index = 0;

        if(b_reset_module != 0)
        {
            unsigned int ui_number_of_modules;

            ui_adq_error = adqGetNumberOfModules(ui_board_index, ui_number_of_modules);            
            
            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf("adqGetNumberOfModules returned 0x%08X\n\n", ui_adq_error);

                printf("Press any key to exit.\n");

                _getch();

                exit(-1);
            }

            while(TRUE)
            {
                printf("\n");

                printf("Please choose the module index 0 - %d (RETURN to exit): ",
                       ui_number_of_modules - 1                                  );

                gets_s(&sz_response[0], 8);

                printf("\n\n");

                if(sz_response[0] == 0)
                {
                    b_terminate = 1;
                
                    break;
                }

                if( sscanf_s(&sz_response[0], "%u", &ui_module_index) != 1 )
                {
                    continue;
                }

                if( (0 <= ui_module_index)&&(ui_module_index < ui_number_of_modules) )
                {
                    break;
                }
            }

            if(b_terminate != 0)
            {
                break;
            }
        }

        if(b_reset_module == 0)
        {
            printf("Press any key to call adqResetBoard for board index: %u\n", 
                   ui_board_index                                               );

            _getch();

            ui_adq_error = adqResetBoard(ui_board_index);            
            
            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf("adqResetBoard returned 0x%08X\n\n", ui_adq_error);

                printf("Press any key to exit.\n");

                _getch();

                exit(-1);
            }
        }
        else
        {
            printf("Press any key to call adqResetModule for board index: %u, module index: %u\n", 
                   ui_board_index,
                   ui_module_index                                                                  );

            _getch();

            ui_adq_error = adqResetModule(ui_board_index, ui_module_index);            
            
            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf("adqResetModule returned 0x%08X\n\n", ui_adq_error);

                printf("Press any key to exit.\n");

                _getch();

                exit(-1);
            }
        }

        printf("\n\n\n");
    }

    adqClose();

    printf("\n\n");

    printf("Press any key to terminate.\n");

    _getch();

    return 0;
}

