#include <windows.h>

#include <stdio.h>
#include <stdlib.h>

#include <tchar.h>

#include <conio.h>

#include "..\\adqDevice.h"

#ifdef WIN64

#pragma comment(lib, "..\\adqDevice_64.lib")

#else

#pragma comment(lib, "..\\adqDevice.lib")

#endif

struct SWriteSingleModule
{
    unsigned int    m_uiBoardIndex;

    unsigned int    m_uiModuleIndex;

    unsigned int    m_uiModuleType;
};

int _tmain(int argc, _TCHAR* argv[])
{
   // Increase the size of the console buffer
    
    HANDLE  h_console = GetStdHandle(STD_OUTPUT_HANDLE);

    COORD coord;

    coord.X = 160;
    
    coord.Y = 9999;
    
    SetConsoleScreenBufferSize(h_console, coord);

    bool b_terminate = false;

    bool b_remote = false;

    wchar_t wsz_remote_name_or_IP_address[128];

    while(true)
    {
        printf( "1. Open local\n"
                "2. Open remote\n"
                "\n"
                "Your choice: 1 or 2 (RETURN to exit): ");

        char sz_response[8];

        gets_s(&sz_response[0], 8);

        printf("\n\n");

        if(sz_response[0] == 0)
        {
            b_terminate = true;
            
            break;
        }

        unsigned int ui_choice = 0;

        if( sscanf_s(&sz_response[0], "%u", &ui_choice) != 1)
        {
            continue;
        }

        if(ui_choice == 1)
        {
            break;
        }

        if(ui_choice == 2)
        {
            b_remote = true;

            printf("Name or IP-Address (RETURN to exit): ");

            _getws_s(&wsz_remote_name_or_IP_address[0], 128);

            printf("\n\n");

            if( wsz_remote_name_or_IP_address[0] == (wchar_t)0 )
            {
                b_terminate = true;
            }

            break;
        }
    }

    if(b_terminate)
    {
        printf("Press any key to exit.\n");

        _getch();

        exit(-1);
    }

    unsigned int ui_adq_error;
    
    if(b_remote)
    {
        wchar_t* pwc_user_name_or_address[2] = {&wsz_remote_name_or_IP_address[0],
                                                NULL                                };

        ui_adq_error = adqOpenEx(pwc_user_name_or_address);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            printf("adqOpenEx returned 0x%08X\n\n", ui_adq_error);

            printf("Press any key to exit.\n");

            _getch();

            exit(-1);
        }
    }
    else
    {
        ui_adq_error = adqOpen();

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            printf("adqOpen returned 0x%08X\n\n", ui_adq_error);

            printf("Press any key to exit.\n");

            _getch();

            exit(-1);
        }
    }

    unsigned int ui_number_of_boards;
    
    ui_adq_error = adqGetNumberOfBoards(ui_number_of_boards);

    if(ui_adq_error != ADQ_ERROR_NONE)
    {
        printf("adqGetNumberOfBoards returned 0x%08X\n\n", ui_adq_error);

        printf("Press any key to exit.\n");

        adqClose();

        _getch();

        exit(-1);
    }

    if(ui_number_of_boards == 0)
    {
        printf("No ADQ boards found!\n\n");

        printf("Press any key to exit.\n");

        adqClose();

        _getch();

        exit(-1);
    }

    printf("%3u ADQ Boards found\n", ui_number_of_boards);

    // Count the number of write single modules

    unsigned int ui_number_of_write_single_modules = 0;

    for(unsigned int ui_board_index = 0; ui_board_index < ui_number_of_boards; ui_board_index++)
    {
        unsigned int ui_number_of_modules;

        ui_adq_error = adqGetNumberOfModules(ui_board_index, ui_number_of_modules);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            printf("    Board index: %3u adqGetNumberOfModules returned 0x%08X\n\n", ui_board_index, ui_adq_error);

            printf("Press any key to continue.\n");

            _getch();

            continue;
        }

        for(unsigned int ui_module_index = 0; ui_module_index < ui_number_of_modules; ui_module_index++)
        {
            unsigned int ui_module_type;

            ui_adq_error = adqGetModuleType(ui_board_index, ui_module_index, ui_module_type);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf("        Board index: %3u Module index: %3u adqGetModuleType returned 0x%08X\n\n", ui_board_index, ui_module_index, ui_adq_error);

                printf("Press any key to continue.\n");

                _getch();

                continue;
            }

            if( (ui_module_type == ADQ_MODULE_TYPE_DO)||(ui_module_type == ADQ_MODULE_TYPE_DIO)||(ui_module_type == ADQ_MODULE_TYPE_AO) )
            {
                ++ui_number_of_write_single_modules;
            }
        }
    }

    if(ui_number_of_write_single_modules == 0)
    {
        printf("No Modules found that support adqWriteSingle!\n\n");

        printf("Press any key to exit.\n");

        adqClose();

        _getch();

        exit(-1);
    }

    unsigned int ui_max_number_of_write_single_modules = ui_number_of_write_single_modules;

    SWriteSingleModule* arr_write_single_modules = new SWriteSingleModule[ui_max_number_of_write_single_modules];

    ui_number_of_write_single_modules = 0;

    for(unsigned int ui_board_index = 0; ui_board_index < ui_number_of_boards; ui_board_index++)
    {
        unsigned int ui_number_of_modules;

        ui_adq_error = adqGetNumberOfModules(ui_board_index, ui_number_of_modules);

        if(ui_adq_error != ADQ_ERROR_NONE)
        {
            printf("    Board index: %3u adqGetNumberOfModules returned 0x%08X\n\n", ui_board_index, ui_adq_error);

            printf("Press any key to continue.\n");

            _getch();

            continue;
        }

        for(unsigned int ui_module_index = 0; ui_module_index < ui_number_of_modules; ui_module_index++)
        {
            unsigned int ui_module_type;

            ui_adq_error = adqGetModuleType(ui_board_index, ui_module_index, ui_module_type);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf("        Board index: %3u Module index: %3u adqGetModuleType returned 0x%08X\n\n", ui_board_index, ui_module_index, ui_adq_error);

                printf("Press any key to continue.\n");

                _getch();

                continue;
            }

            SADQGeneralModuleInfo s_adq_general_module_info;

            s_adq_general_module_info.m_uiSize = sizeof(SADQGeneralModuleInfo);

            s_adq_general_module_info.m_uiID = SADQGeneralModuleInfo_ID;

            if( (ui_module_type == ADQ_MODULE_TYPE_DO)||(ui_module_type == ADQ_MODULE_TYPE_DIO)||(ui_module_type == ADQ_MODULE_TYPE_AO) )
            {
                unsigned int ui_info_size;

                ui_adq_error = adqGetModuleInfo(ui_board_index, ui_module_index, s_adq_general_module_info, 0, NULL, ui_info_size);

                if(ui_adq_error != ADQ_ERROR_NONE)
                {
                    printf("        Board index: %3u Module index: %3u adqGetModuleInfo returned 0x%08X\n\n", ui_board_index, ui_module_index, ui_adq_error);

                    printf("Press any key to continue.\n");

                    _getch();

                    continue;
                }

                arr_write_single_modules[ui_number_of_write_single_modules].m_uiBoardIndex = ui_board_index;

                arr_write_single_modules[ui_number_of_write_single_modules].m_uiModuleIndex = ui_module_index;

                arr_write_single_modules[ui_number_of_write_single_modules].m_uiModuleType = ui_module_type;

                ++ui_number_of_write_single_modules;
            }
        }
    }

    while(true)
    {
        printf("Please choose a module for adqWriteSingle:\n\n");

        unsigned int ui_index_write_single_module;

        for(ui_index_write_single_module = 0; ui_index_write_single_module < ui_number_of_write_single_modules; ui_index_write_single_module++)
        {
            wchar_t* wsz_module_type = L"???????";

            switch(arr_write_single_modules[ui_index_write_single_module].m_uiModuleType)
            {
            case ADQ_MODULE_TYPE_DO:

                wsz_module_type = L"     DO";

                break;

            case ADQ_MODULE_TYPE_DIO:
                
                wsz_module_type = L"    DIO";

                break;

            case ADQ_MODULE_TYPE_AO:
                
                wsz_module_type = L"     AO";

                break;
            }


            printf("%2u.  Board index: %d  Module index: %-2d  Module type: %S\n",
                   ui_index_write_single_module + 1,
                   arr_write_single_modules[ui_index_write_single_module].m_uiBoardIndex,
                   arr_write_single_modules[ui_index_write_single_module].m_uiModuleIndex,
                   wsz_module_type                                                        );
        }

        printf("\n");

        printf("Your choice 1 - %d (RETURN to exit): ",
                ui_number_of_write_single_modules         );

        char sz_response[8];

        gets_s(&sz_response[0], 8);

        printf("\n\n");

        if(sz_response[0] == 0)
        {
            break;
        }

        if( sscanf_s(&sz_response[0], "%u", &ui_index_write_single_module) != 1)
        {
            continue;
        }

        if( (ui_index_write_single_module < 1)||(ui_index_write_single_module > ui_number_of_write_single_modules) )
        {
            continue;
        }

        --ui_index_write_single_module;

        unsigned int ui_board_index = arr_write_single_modules[ui_index_write_single_module].m_uiBoardIndex;

        unsigned int ui_module_index = arr_write_single_modules[ui_index_write_single_module].m_uiModuleIndex;

        bool b_terminate = false;

        double d_factor = 1.0;
        
        double d_constant = 0.0; 

        double d_physical_min = 0.0;

        double d_physical_max = 0.0;

        unsigned int ui_digital_min;

        unsigned int ui_digital_max;

        wchar_t* wsz_physical_unit = L"????";

        unsigned int ui_channel_index = 0;

        switch(arr_write_single_modules[ui_index_write_single_module].m_uiModuleType)
        {
        case ADQ_MODULE_TYPE_DIO:

            // Switch to input

            ui_adq_error = adqDIOSetDirection(ui_board_index, ui_module_index, ADQ_DIO_OUTPUT);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf("        Board index: %3u Module index: %3u direction: Input (0x%08X) - adqDIOSetDirection returned 0x%08X\n\n", ui_board_index, ui_module_index, ADQ_DIO_INPUT, ui_adq_error);

                printf("Press any key to continue.\n");

                _getch();

                continue;
            }

            break;

        case ADQ_MODULE_TYPE_AO:

            // Ask the user for the range

            SADQGeneralModuleInfo s_adq_general_module_info;

            s_adq_general_module_info.m_uiSize = sizeof(SADQGeneralModuleInfo);

            s_adq_general_module_info.m_uiID = SADQGeneralModuleInfo_ID;

            SADQAOModuleInfo s_adq_ao_module_info;

            s_adq_ao_module_info.m_uiSize = sizeof(SADQAOModuleInfo);

            s_adq_ao_module_info.m_uiID = SADQAOModuleInfo_ID;

            unsigned int ui_info_size;

            ui_adq_error = adqGetModuleInfo(ui_board_index, ui_module_index, s_adq_general_module_info, sizeof(SADQAOModuleInfo), (unsigned char*)&s_adq_ao_module_info, ui_info_size);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf("        Board index: %3u Module index: %3u adqGetModuleInfo returned 0x%08X\n\n", ui_board_index, ui_module_index, ui_adq_error);

                printf("Press any key to continue.\n");

                _getch();

                continue;
            }

            bool b_continue = false;

            unsigned int ui_range_index;
            ui_range_index = 0;

            if(s_adq_ao_module_info.m_uiNumberOfRanges > 1)
            {
                b_continue = false;
            
                while(true)
                {
                    printf("The channel has the following output ranges:\n\n");
                 
                    for(unsigned int ui_index_range = 0; ui_index_range < s_adq_ao_module_info.m_uiNumberOfRanges; ui_index_range++)
                    {
                        if(s_adq_ao_module_info.m_arrRanges[ui_index_range].m_uiPhysicalUnit == ADQ_PHYSICAL_UNIT_VOLT)
                        {
                            wsz_physical_unit = L"Volt";
                        }
                        else if(s_adq_ao_module_info.m_arrRanges[ui_index_range].m_uiPhysicalUnit == ADQ_PHYSICAL_UNIT_AMPERE)
                        {
                            wsz_physical_unit = L"Ampere";
                        }
                        else // if(s_adq_ao_module_info.m_arrRanges[ui_index_range].m_uiPhysicalUnit == ADQ_PHYSICAL_UNIT_OHM)
                        {
                            wsz_physical_unit = L"Ohm";
                        }

                        printf( "%2d.  Digital Min.: %u  Digital Max.: %u  Unit: %6S  Physical Min.: %7.4f  Physical Max.: %7.4f\n",
                                ui_index_range,
                                s_adq_ao_module_info.m_arrRanges[ui_index_range].m_uiDigitalMin,
                                s_adq_ao_module_info.m_arrRanges[ui_index_range].m_uiDigitalMax,
                                wsz_physical_unit,
                                s_adq_ao_module_info.m_arrRanges[ui_index_range].m_dPhysicalMin,
                                s_adq_ao_module_info.m_arrRanges[ui_index_range].m_dPhysicalMax                                     );
                    }

                    printf("\n");

                    printf("Your choice 0 - %u (RETURN to exit): ",
                           s_adq_ao_module_info.m_uiNumberOfRanges - 1  );

                    char sz_response[8];

                    gets_s(&sz_response[0], 8);

                    printf("\n\n");

                    if(sz_response[0] == 0)
                    {
                        b_continue = true;
                    
                        break;
                    }

                    if( sscanf_s(&sz_response[0], "%u", &ui_range_index) != 1)
                    {
                        continue;
                    }

                    if(ui_range_index >= s_adq_ao_module_info.m_uiNumberOfRanges)
                    {
                        continue;
                    }

                    break;
                }

                if(b_continue)
                {
                    continue;
                }
            }


/* ????

            ui_adq_error = adqAOSetRange(ui_board_index, ui_module_index, ui_range_index);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf("        Board index: %3u Module index: %3u channel index: %u range index: %u - adqAISetChannelAndRange returned 0x%08X\n\n", ui_board_index, ui_module_index, ui_channel_index, ui_range_index, ui_adq_error);

                printf("Press any key to continue.\n");

                _getch();

                continue;
            }

*/

            d_factor = (double)(s_adq_ao_module_info.m_arrRanges[ui_range_index].m_uiDigitalMax - s_adq_ao_module_info.m_arrRanges[ui_range_index].m_uiDigitalMin) / 
                                                        (s_adq_ao_module_info.m_arrRanges[ui_range_index].m_dPhysicalMax - s_adq_ao_module_info.m_arrRanges[ui_range_index].m_dPhysicalMin);
                                        ;
        
            d_constant = (double)s_adq_ao_module_info.m_arrRanges[ui_range_index].m_uiDigitalMin - s_adq_ao_module_info.m_arrRanges[ui_range_index].m_dPhysicalMin * d_factor; 

            if(s_adq_ao_module_info.m_arrRanges[ui_range_index].m_uiPhysicalUnit == ADQ_PHYSICAL_UNIT_VOLT)
            {
                wsz_physical_unit = L"Volt";
            }
            else if(s_adq_ao_module_info.m_arrRanges[ui_range_index].m_uiPhysicalUnit == ADQ_PHYSICAL_UNIT_AMPERE)
            {
                wsz_physical_unit = L"Ampere";
            }
            else // if(s_adq_ao_module_info.m_arrRanges[ui_range_index].m_uiPhysicalUnit == ADQ_PHYSICAL_UNIT_OHM)
            {
                wsz_physical_unit = L"Ohm";
            }

            d_physical_min = s_adq_ao_module_info.m_arrRanges[ui_range_index].m_dPhysicalMin;

            d_physical_max = s_adq_ao_module_info.m_arrRanges[ui_range_index].m_dPhysicalMax;

            ui_digital_min = s_adq_ao_module_info.m_arrRanges[ui_range_index].m_uiDigitalMin;

            ui_digital_max = s_adq_ao_module_info.m_arrRanges[ui_range_index].m_uiDigitalMax;

            break;
        }

        while(true)
        {
            unsigned int ui_value = 0;

            if(arr_write_single_modules[ui_index_write_single_module].m_uiModuleType == ADQ_MODULE_TYPE_AO)
            {
                printf( "Output to Board index: %u, Module index: %u (RETURN to  exit) %S: ",
                        ui_board_index,
                        ui_module_index,
                        wsz_physical_unit                                                       );

                char sz_response[64];

                gets_s(&sz_response[0], 64);

                printf("\n\n");

                if(sz_response[0] == 0)
                {
                    break;
                }

                double d_physical;

                if( sscanf_s(&sz_response[0], "%lf", &d_physical) != 1)
                {
                    continue;
                }

                if(d_physical < d_physical_min)
                {
                    printf( "!!!! Value %f %S lies outside range %f %S - %f %S, outputting %f %S\n\n",
                            d_physical,
                            wsz_physical_unit,
                            d_physical_min,
                            wsz_physical_unit,
                            d_physical_max,
                            wsz_physical_unit,
                            d_physical_min,
                            wsz_physical_unit                                                        );

                    d_physical = d_physical_min;

                    printf("Press any key to continue\n\n");

                    _getch();
                }
                else if(d_physical > d_physical_max)
                {
                    printf( "!!!! Value %f %S lies outside range %f %S - %f %S, outputting %f %S\n\n",
                            d_physical,
                            wsz_physical_unit,
                            d_physical_min,
                            wsz_physical_unit,
                            d_physical_max,
                            wsz_physical_unit,
                            d_physical_min,
                            wsz_physical_unit                                                        );

                    d_physical = d_physical_max;

                    printf("Press any key to continue\n\n");

                    _getch();
                }

                double d_digital = d_physical * d_factor + d_constant;

                if(d_digital <= (double)ui_digital_min)
                {
                    ui_value = ui_digital_min;
                }
                else if(d_digital >= (double)ui_digital_max)
                {
                    ui_value = ui_digital_max;
                }
                else
                {
                    ui_value = (unsigned int)(d_physical * d_factor + d_constant);
                }

                printf("Output %f %S (Digital %u) to Board index: %u, Module index: %u\n\n",
                        d_physical,
                        wsz_physical_unit,
                        ui_value,
                        ui_board_index,
                        ui_module_index                                                         );
            }
            else
            {
                printf( "Output to Board index: %u, Module index: %u (RETURN to  exit) 0x: ",
                        ui_board_index,
                        ui_module_index,
                        wsz_physical_unit                                                                                                );

                char sz_response[16];

                gets_s(&sz_response[0], 16);

                printf("\n\n");

                if(sz_response[0] == 0)
                {
                    break;
                }

                if( sscanf_s(&sz_response[0], "%X", &ui_value) != 1)
                {
                    continue;
                }

                printf("Output 0x%08X to Board index: %u, Module index: %u\n\n",
                        ui_value,
                        ui_board_index,
                        ui_module_index                                         );
            }

            ui_adq_error = adqWriteSingle(ui_board_index, ui_module_index, ui_value);

            if(ui_adq_error != ADQ_ERROR_NONE)
            {
                printf( "Board index: %3u Module index: %3u - adqWriteSingle returned 0x%08X\n\n", 
                        ui_board_index,
                        ui_module_index,
                        ui_adq_error                                                                );

                printf("Press any key to exit.\n");

                adqClose();

                _getch();

                exit(-1);
            }
        }

        printf("\n\n");

        printf("Press any key to continue\n\n");

        _getch();
    }

    printf("\n\n");

    delete []arr_write_single_modules;

    adqClose();

    printf("Press any key to terminate.\n");

    _getch();

    return 0;
}

