//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// https://www.alldaq.com
//
// Purpose:
//       This file is part of the adqWriteContinuousCallback project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------

#include "stdafx.h"
#include "SineWaveGenerator.h"

#include <cmath>


SineWaveGenerator::SineWaveGenerator()
{
}

SineWaveGenerator::~SineWaveGenerator()
{
}

std::wstring SineWaveGenerator::GetGeneratorName()
{
    return L"Sine wave";
}

double SineWaveGenerator::GetValue(double cycleTime, double signalMaximum)
{
    return signalMaximum * (std::sin)(TwoPi * cycleTime);
}
