//-----------------------------------------------------------------------------
// ALLDAQ, a division of ALLNET GmbH
// https://www.alldaq.com
//
// Purpose:
//       This file is part of the adqWriteContinuousWithoutCallback project of the ALLDAQ-SDK.  
//       It shows the usage of the API functions to access
//       ALLDAQ Data Acquisition Boards
// 
//-----------------------------------------------------------------------------

#pragma once

#include <string>

class AoRange
{
public:
    AoRange(unsigned int rangeIndex, unsigned int digitalMin, unsigned int digitalMax, 
        unsigned int physicalUnit, double physicalMin, double physicalMax);
    ~AoRange();
    unsigned int PhysicalToDigital(double physicalValue);

    double GetPhysicalMax();
    double GetPhysicalMin();

    std::wstring GetRangeText();
    std::wstring GetUnitSymbol();
private:
    unsigned int m_rangeIndex;
    unsigned int m_digitalMin;
    unsigned int m_digitalMax;
    double m_physicalMin;
    double m_physicalMax;
    
    std::wstring m_unitSymbol;
    std::wstring m_rangeText;

    double m_physicalResolution;
    double m_digitalOffset;

    void SetRangeText();
};
