//-----------------------------------------------------------------------------
// adqDeviceLoadDll.cpp - function prototypes for ALLDAQ driver system API
//      Copyright (c) ALLDAQ, a division of ALLNET GmbH
//      https://www.alldaq.com
//
// Purpose:
//      This file has function wrappers for explicitly linking to the exported
//      dll functions used by ALLDAQ measurement boards
//-----------------------------------------------------------------------------


#include "adqDeviceLoadDll.h"

#define ADQ_ERROR_FUNCTION_NOT_FOUND (ADQ_ERROR_TYPE_FATAL | ADQ_ERROR_UNSUPPORTED)

//-----------------------------------------------------------------------------
// API-function pointers
//-----------------------------------------------------------------------------
fptr_adqGetInternalError fp_adqGetInternalError = nullptr;
fptr_adqOpen fp_adqOpen = nullptr;
fptr_adqOpenEx fp_adqOpenEx = nullptr;
fptr_adqGetNumberOfUsers fp_adqGetNumberOfUsers = nullptr;
fptr_adqGetSystemInfo fp_adqGetSystemInfo = nullptr;
fptr_adqQuery fp_adqQuery = nullptr;
fptr_adqGetNumberOfBoards fp_adqGetNumberOfBoards = nullptr;
fptr_adqGetBoardInfo fp_adqGetBoardInfo = nullptr;
fptr_adqGetBoardPCIInfo fp_adqGetBoardPCIInfo = nullptr;
fptr_adqResetBoard fp_adqResetBoard = nullptr;
fptr_adqGetBoardTTLVoltage fp_adqGetBoardTTLVoltage = nullptr;
fptr_adqSetBoardTTLVoltage fp_adqSetBoardTTLVoltage = nullptr;
fptr_adqGetNumberOfModules fp_adqGetNumberOfModules = nullptr;
fptr_adqGetBoardSynchronStartInfo fp_adqGetBoardSynchronStartInfo = nullptr;
fptr_adqConfigBoardSynchronStart fp_adqConfigBoardSynchronStart = nullptr;
fptr_adqBoardSynchronStart fp_adqBoardSynchronStart = nullptr;
fptr_adqGetModuleType fp_adqGetModuleType = nullptr;
fptr_adqGetModuleInfo fp_adqGetModuleInfo = nullptr;
fptr_adqResetModule fp_adqResetModule = nullptr;
fptr_adqGetMaximumSampleFrequency fp_adqGetMaximumSampleFrequency = nullptr;
fptr_adqSetFrequency fp_adqSetFrequency = nullptr;
fptr_adqGetHWTriggerInfo fp_adqGetHWTriggerInfo = nullptr;
fptr_adqEnableHWTrigger fp_adqEnableHWTrigger = nullptr;
fptr_adqDisableHWTrigger fp_adqDisableHWTrigger = nullptr;
fptr_adqReadSingle fp_adqReadSingle = nullptr;
fptr_adqReadBuffer fp_adqReadBuffer = nullptr;
fptr_adqReadContinuousStart fp_adqReadContinuousStart = nullptr;
fptr_adqReadContinuous fp_adqReadContinuous = nullptr;
fptr_adqReadContinuousStatus fp_adqReadContinuousStatus = nullptr;
fptr_adqWriteSingle fp_adqWriteSingle = nullptr;
fptr_adqWriteBuffer fp_adqWriteBuffer = nullptr;
fptr_adqWriteContinuousStart fp_adqWriteContinuousStart = nullptr;
fptr_adqWriteContinuous fp_adqWriteContinuous = nullptr;
fptr_adqWriteContinuousStatus fp_adqWriteContinuousStatus = nullptr;
fptr_adqStop fp_adqSart = nullptr;
fptr_adqStop fp_adqStop = nullptr;
fptr_adqGetIRQInfo fp_adqGetIRQInfo = nullptr;
fptr_adqEnableIRQ fp_adqEnableIRQ = nullptr;
fptr_adqWaitIRQ fp_adqWaitIRQ = nullptr;
fptr_adqGetIRQCount fp_adqGetIRQCount = nullptr;
fptr_adqDisableIRQ fp_adqDisableIRQ = nullptr;
fptr_adqDIOGetDirection fp_adqDIOGetDirection = nullptr;
fptr_adqDIOSetDirection fp_adqDIOSetDirection = nullptr;
fptr_adqDIOGetFilterPicoseconds fp_adqDIOGetFilterPicoseconds = nullptr;
fptr_adqDIOSetFilterPicoseconds fp_adqDIOSetFilterPicoseconds = nullptr;
fptr_adqCNTRConfig fp_adqCNTRConfig = nullptr;
fptr_adqCNTRConfigEx fp_adqCNTRConfigEx = nullptr;
fptr_adqCNTREnable fp_adqCNTREnable = nullptr;
fptr_adqCNTRDisable fp_adqCNTRDisable = nullptr;
fptr_adqAISetChannelAndRange fp_adqAISetChannelAndRange = nullptr;
fptr_adqAIGetChannelHardwareRange fp_adqAIGetChannelHardwareRange = nullptr;
fptr_adqAISetChannelList fp_adqAISetChannelList = nullptr;
fptr_adqAISetChannelListAndFrequency fp_adqAISetChannelListAndFrequency = nullptr;
fptr_adqAIReadSingle fp_adqAIReadSingle = nullptr;
fptr_adqAIReadBuffer fp_adqAIReadBuffer = nullptr;
fptr_adqAIReadContinuousStart fp_adqAIReadContinuousStart = nullptr;
fptr_adqAIReadContinuous fp_adqAIReadContinuous = nullptr;
fptr_adqAIReadContinuousStatus fp_adqAIReadContinuousStatus = nullptr;
fptr_adqAnalogGetSelectedCalibration fp_adqAnalogGetSelectedCalibration = nullptr;
fptr_adqAnalogSelectCalibration fp_adqAnalogSelectCalibration = nullptr;
fptr_adqAISetCalibrationZero fp_adqAISetCalibrationZero = nullptr;
fptr_adqAnalogGetNumberOfUserCalibrations fp_adqAnalogGetNumberOfUserCalibrations = nullptr;
fptr_adqAnalogSetTemporaryCalibration fp_adqAnalogSetTemporaryCalibration = nullptr;
fptr_adqAnalogGetCalibrationFactorAndConstant fp_adqAnalogGetCalibrationFactorAndConstant = nullptr;
fptr_adqI2CSetSlaveAddress fp_adqI2CSetSlaveAddress = nullptr;
fptr_adqI2CRead fp_adqI2CRead = nullptr;
fptr_adqI2CWrite fp_adqI2CWrite = nullptr;
fptr_adqI2CWriteThenRead fp_adqI2CWriteThenRead = nullptr;
fptr_adqPWMGetMaximumFrequency fp_adqPWMGetMaximumFrequency = nullptr;
fptr_adqPWMConfig fp_adqPWMConfig = nullptr;
fptr_adqPWMEnable fp_adqPWMEnable = nullptr;
fptr_adqPWMDisable fp_adqPWMDisable = nullptr;
fptr_adqFINRead fp_adqFINRead = nullptr;
fptr_adqI2SOSineConfig fp_adqI2SOSineConfig = nullptr;
fptr_adqI2SOSineStart fp_adqI2SOSineStart = nullptr;
fptr_adqI2SOSineModify fp_adqI2SOSineModify = nullptr;
fptr_adqI2SOSineStop fp_adqI2SOSineStop = nullptr;
fptr_adqClose fp_adqClose = nullptr;


HINSTANCE hDeviceDll = nullptr;

//-----------------------------------------------------------------------------
// load library and free library function implementation
//-----------------------------------------------------------------------------
unsigned int adqDeviceLoadLibrary(void)
{
    hDeviceDll = LoadLibrary(ADQ_DEVICE_DLL);
    if (hDeviceDll == nullptr)
    {
        return ADQ_ERROR_TYPE_FATAL | ADQ_ERROR_INTERNAL;
    }

    fp_adqGetInternalError = (fptr_adqGetInternalError)
        (GetProcAddress(hDeviceDll, "adqGetInternalError"));

    fp_adqOpen = (fptr_adqOpen)
        (GetProcAddress(hDeviceDll, "adqOpen"));

    fp_adqOpenEx = (fptr_adqOpenEx)
        (GetProcAddress(hDeviceDll, "adqOpenEx"));

    fp_adqGetNumberOfUsers = (fptr_adqGetNumberOfUsers)
        (GetProcAddress(hDeviceDll, "adqGetNumberOfUsers"));

    fp_adqGetSystemInfo = (fptr_adqGetSystemInfo)
        (GetProcAddress(hDeviceDll, "adqGetSystemInfo"));

    fp_adqQuery = (fptr_adqQuery)
        (GetProcAddress(hDeviceDll, "adqQuery"));

    fp_adqGetNumberOfBoards = (fptr_adqGetNumberOfBoards)
        (GetProcAddress(hDeviceDll, "adqGetNumberOfBoards"));

    fp_adqGetBoardInfo = (fptr_adqGetBoardInfo)
        (GetProcAddress(hDeviceDll, "adqGetBoardInfo"));

    fp_adqGetBoardPCIInfo = (fptr_adqGetBoardPCIInfo)
        (GetProcAddress(hDeviceDll, "adqGetBoardPCIInfo"));

    fp_adqResetBoard = (fptr_adqResetBoard)
        (GetProcAddress(hDeviceDll, "adqResetBoard"));

    fp_adqGetBoardTTLVoltage = (fptr_adqGetBoardTTLVoltage)
        (GetProcAddress(hDeviceDll, "adqGetBoardTTLVoltage"));

    fp_adqSetBoardTTLVoltage = (fptr_adqSetBoardTTLVoltage)
        (GetProcAddress(hDeviceDll, "adqSetBoardTTLVoltage"));

    fp_adqGetNumberOfModules = (fptr_adqGetNumberOfModules)
        (GetProcAddress(hDeviceDll, "adqGetNumberOfModules"));
	
	fp_adqGetNumberOfModules = (fptr_adqGetBoardSynchronStartInfo)
		(GetProcAddress(hDeviceDll, "adqGetBoardSynchronStartInfo"));

	fp_adqGetNumberOfModules = (fptr_adqConfigBoardSynchronStart)
		(GetProcAddress(hDeviceDll, "adqConfigBoardSynchronStart"));

	fp_adqGetNumberOfModules = (fptr_adqBoardSynchronStart)
		(GetProcAddress(hDeviceDll, "adqBoardSynchronStart"));
	
    fp_adqGetModuleType = (fptr_adqGetModuleType)
        (GetProcAddress(hDeviceDll, "adqGetModuleType"));

    fp_adqGetModuleInfo = (fptr_adqGetModuleInfo)
        (GetProcAddress(hDeviceDll, "adqGetModuleInfo"));

    fp_adqResetModule = (fptr_adqResetModule)
        (GetProcAddress(hDeviceDll, "adqResetModule"));

    fp_adqGetMaximumSampleFrequency = (fptr_adqGetMaximumSampleFrequency)
        (GetProcAddress(hDeviceDll, "adqGetMaximumSampleFrequency"));

    fp_adqSetFrequency = (fptr_adqSetFrequency)
        (GetProcAddress(hDeviceDll, "adqSetFrequency"));

    fp_adqGetHWTriggerInfo = (fptr_adqGetHWTriggerInfo)
        (GetProcAddress(hDeviceDll, "adqGetHWTriggerInfo"));

    fp_adqEnableHWTrigger = (fptr_adqEnableHWTrigger)
        (GetProcAddress(hDeviceDll, "adqEnableHWTrigger"))

        fp_adqDisableHWTrigger = (fptr_adqDisableHWTrigger)
        (GetProcAddress(hDeviceDll, "adqDisableHWTrigger"))

        fp_adqReadSingle = (fptr_adqReadSingle)
        (GetProcAddress(hDeviceDll, "adqReadSingle"));

    fp_adqReadBuffer = (fptr_adqReadBuffer)
        (GetProcAddress(hDeviceDll, "adqReadBuffer"));

    fp_adqReadContinuousStart = (fptr_adqReadContinuousStart)
        (GetProcAddress(hDeviceDll, "adqReadContinuousStart"));

    fp_adqReadContinuous = (fptr_adqReadContinuous)
        (GetProcAddress(hDeviceDll, "adqReadContinuous"));

    fp_adqReadContinuousStatus = (fptr_adqReadContinuousStatus)
        (GetProcAddress(hDeviceDll, "adqReadContinuousStatus"));

    fp_adqWriteSingle = (fptr_adqWriteSingle)
        (GetProcAddress(hDeviceDll, "adqWriteSingle"));

    fp_adqWriteBuffer = (fptr_adqWriteBuffer)
        (GetProcAddress(hDeviceDll, "adqWriteBuffer"));

    fp_adqWriteContinuousStart = (fptr_adqWriteContinuousStart)
        (GetProcAddress(hDeviceDll, "adqWriteContinuousStart"));

    fp_adqWriteContinuous = (fptr_adqWriteContinuous)
        (GetProcAddress(hDeviceDll, "adqWriteContinuous"));

    fp_adqWriteContinuousStatus = (fptr_adqWriteContinuousStatus)
        (GetProcAddress(hDeviceDll, "adqWriteContinuousStatus"));

    fp_adqStop = (fptr_adqStop)
        (GetProcAddress(hDeviceDll, "adqStop"));

    fp_adqGetIRQInfo = (fptr_adqGetIRQInfo)
        (GetProcAddress(hDeviceDll, "adqGetIRQInfo"));

    fp_adqEnableIRQ = (fptr_adqEnableIRQ)
        (GetProcAddress(hDeviceDll, "adqEnableIRQ"));

    fp_adqWaitIRQ = (fptr_adqWaitIRQ)
        (GetProcAddress(hDeviceDll, "adqWaitIRQ"));

    fp_adqGetIRQCount = (fptr_adqGetIRQCount)
        (GetProcAddress(hDeviceDll, "adqGetIRQCount"));

    fp_adqDisableIRQ = (fptr_adqDisableIRQ)
        (GetProcAddress(hDeviceDll, "adqDisableIRQ"));

    fp_adqDIOGetDirection = (fptr_adqDIOGetDirection)
        (GetProcAddress(hDeviceDll, "adqDIOGetDirection"));

    fp_adqDIOSetDirection = (fptr_adqDIOSetDirection)
        (GetProcAddress(hDeviceDll, "adqDIOSetDirection"));

    fp_adqDIOGetFilterPicoseconds = (fptr_adqDIOGetFilterPicoseconds)
        (GetProcAddress(hDeviceDll, "adqDIOGetFilterPicoseconds"));

    fp_adqDIOSetFilterPicoseconds = (fptr_adqDIOSetFilterPicoseconds)
        (GetProcAddress(hDeviceDll, "adqDIOSetFilterPicoseconds"));

    fp_adqCNTRConfig = (fptr_adqCNTRConfig)
        (GetProcAddress(hDeviceDll, "adqCNTRConfig"));

    fp_adqCNTRConfigEx = (fptr_adqCNTRConfigEx)
        (GetProcAddress(hDeviceDll, "adqCNTRConfigEx"));

    fp_adqCNTREnable = (fptr_adqCNTREnable)
        (GetProcAddress(hDeviceDll, "adqCNTREnable"));

    fp_adqCNTRDisable = (fptr_adqCNTRDisable)
        (GetProcAddress(hDeviceDll, "adqCNTRDisable"));

    fp_adqAISetChannelAndRange = (fptr_adqAISetChannelAndRange)
        (GetProcAddress(hDeviceDll, "adqAISetChannelAndRange"));

    fp_adqAIGetChannelHardwareRange = (fptr_adqAIGetChannelHardwareRange)
        (GetProcAddress(hDeviceDll, "adqAIGetChannelHardwareRange"));

    fp_adqAISetChannelList = (fptr_adqAISetChannelList)
        (GetProcAddress(hDeviceDll, "adqAISetChannelList"));

    fp_adqAISetChannelListAndFrequency = (fptr_adqAISetChannelListAndFrequency)
        (GetProcAddress(hDeviceDll, "adqAISetChannelListAndFrequency"));

    fp_adqAIReadSingle = (fptr_adqAIReadSingle)
        (GetProcAddress(hDeviceDll, "adqAIReadSingle"));

    fp_adqAIReadBuffer = (fptr_adqAIReadBuffer)
        (GetProcAddress(hDeviceDll, "adqAIReadBuffer"));

    fp_adqAIReadContinuousStart = (fptr_adqAIReadContinuousStart)
        (GetProcAddress(hDeviceDll, "adqAIReadContinuousStart"));

    fp_adqAIReadContinuous = (fptr_adqAIReadContinuous)
        (GetProcAddress(hDeviceDll, "adqAIReadContinuous"));

    fp_adqAIReadContinuousStatus = (fptr_adqAIReadContinuousStatus)
        (GetProcAddress(hDeviceDll, "adqAIReadContinuousStatus"));

    fp_adqAnalogGetSelectedCalibration = (fptr_adqAnalogGetSelectedCalibration)
        (GetProcAddress(hDeviceDll, "adqAnalogGetSelectedCalibration"));

    fp_adqAnalogSelectCalibration = (fptr_adqAnalogSelectCalibration)
        (GetProcAddress(hDeviceDll, "adqAnalogSelectCalibration"));

    fp_adqAISetCalibrationZero = (fptr_adqAISetCalibrationZero)
        (GetProcAddress(hDeviceDll, "adqAISetCalibrationZero"));

    fp_adqAnalogGetNumberOfUserCalibrations = (fptr_adqAnalogGetNumberOfUserCalibrations)
        (GetProcAddress(hDeviceDll, "adqAnalogGetNumberOfUserCalibrations"));

    fp_adqAnalogSetTemporaryCalibration = (fptr_adqAnalogSetTemporaryCalibration)
        (GetProcAddress(hDeviceDll, "adqAnalogSetTemporaryCalibration"));

	fp_adqAnalogGetCalibrationFactorAndConstant = (fptr_adqAnalogGetCalibrationFactorAndConstant)
		(GetProcAddress(hDeviceDll, "adqAnalogGetCalibrationFactorAndConstant"));

    fp_adqI2CSetSlaveAddress = (fptr_adqI2CSetSlaveAddress)
        (GetProcAddress(hDeviceDll, "adqI2CSetSlaveAddress"));

    fp_adqI2CRead = (fptr_adqI2CRead)
        (GetProcAddress(hDeviceDll, "adqI2CRead"));

    fp_adqI2CWrite = (fptr_adqI2CWrite)
        (GetProcAddress(hDeviceDll, "adqI2CWrite"));

    fp_adqI2CWriteThenRead = (fptr_adqI2CWriteThenRead)
        (GetProcAddress(hDeviceDll, "adqI2CWriteThenRead"));

    fp_adqPWMGetMaximumFrequency = (fptr_adqPWMGetMaximumFrequency)
        (GetProcAddress(hDeviceDll, "adqPWMGetMaximumFrequency"));

    fp_adqPWMConfig = (fptr_adqPWMConfig)
        (GetProcAddress(hDeviceDll, "adqPWMConfig");

    fp_adqPWMEnable = (fptr_adqPWMEnable)
        (GetProcAddress(hDeviceDll, "adqPWMEnable"));

    fp_adqPWMDisable = (fptr_adqPWMDisable)
        (GetProcAddress(hDeviceDll, "adqPWMDisable"));

    fp_adqFINRead = (fptr_adqFINRead)
        (GetProcAddress(hDeviceDll, "adqFINRead"));

    fp_adqI2SOSineConfig = (fptr_adqI2SOSineConfig)
        (GetProcAddress(hDeviceDll, "adqI2SOSineConfig"));

    fp_adqI2SOSineStart = (fptr_adqI2SOSineStart)
        (GetProcAddress(hDeviceDll, "adqI2SOSineStart"));

    fp_adqI2SOSineModify = (fptr_adqI2SOSineModify)
        (GetProcAddress(hDeviceDll, "adqI2SOSineModify"));

    fp_adqI2SOSineStop = (fptr_adqI2SOSineStop)
        (GetProcAddress(hDeviceDll, "adqI2SOSineStop"));

    fp_adqClose = (fptr_adqClose)
        (GetProcAddress(hDeviceDll, "adqClose"));

    return ADQ_ERROR_NONE;
}

unsigned int adqDeviceFreeLibrary(void)
{
    if (hDeviceDll)
    {
        FreeLibrary(hDeviceDll);
    }
    return ADQ_ERROR_NONE;
}


//-----------------------------------------------------------------------------
// API wrapper functions
//-----------------------------------------------------------------------------
unsigned int adqGetInternalError(
    unsigned int& uiComponent,
    unsigned int& uiFile,
    unsigned int& uiLineNumber,
    unsigned int& uiType,
    unsigned int& uiErrorParameter1,
    unsigned int& uiErrorParameter2)
{
    if (fp_adqGetInternalError)
    {
        return (fp_adqGetInternalError)(uiComponent, uiFile, uiLineNumber, uiType, uiErrorParameter1, uiErrorParameter2);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqOpen(void)
{
    if (fp_adqOpen)
    {
        return (fp_adqOpen)();
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqOpenEx(
    wchar_t** ppwcNameOrIPAddress)
{
    if (fp_adqOpenEx)
    {
        return (fp_adqOpenEx)(ppwcNameOrIPAddress);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetNumberOfUsers(
    unsigned int& uiNumberOfUsers)
{
    if (fp_adqGetNumberOfUsers)
    {
        return adqGetNumberOfUsers(uiNumberOfUsers);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetSystemInfo(
    SADQSystemInfo & sSystemInfo)
{
    if (fp_adqGetSystemInfo)
    {
        return adqGetSystemInfo(sSystemInfo);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqQuery(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiID,
    unsigned int uiSubId,
    unsigned int uiBufferSize,
    unsigned char* pucBuffer,
    unsigned int& uiInfoSize)
{
    if (fp_adqQuery)
    {
        return adqQuery(uiBoardIndex, uiModuleIndex, uiID, uiSubId, uiBufferSize, pucBuffer, uiInfoSize);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetNumberOfBoards(
    unsigned int& uiNumberOfBoards)
{
    if (fp_adqGetNumberOfBoards)
    {
        return adqGetNumberOfBoards(uiNumberOfBoards);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetBoardInfo(
    unsigned int uiBoardIndex,
    SADQBoardInfo & sBoardInfo)
{
    if (fp_adqGetBoardInfo)
    {
        return (fp_adqGetBoardInfo)(uiBoardIndex, sBoardInfo);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetBoardPCIInfo(
    unsigned int uiBoardIndex,
    SADQBoardPCIInfo & sBoardPCIInfo)
{
    if (fp_adqGetBoardPCIInfo)
    {
        return (fp_adqGetBoardPCIInfo)(uiBoardIndex, sBoardPCIInfo);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqResetBoard(
    unsigned int uiBoardIndex)
{
    if (fp_adqResetBoard)
    {
        return (fp_adqResetBoard)(uiBoardIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetBoardTTLVoltage(
    unsigned int uiBoardIndex,
    unsigned int& uiVoltage)
{
    if (fp_adqGetBoardTTLVoltage)
    {
        return (fp_adqGetBoardTTLVoltage)(uiBoardIndex, uiVoltage);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqSetBoardTTLVoltage(
    unsigned int uiBoardIndex,
    unsigned int uiVoltage)
{
    if (fp_adqSetBoardTTLVoltage)
    {
        return (fp_adqSetBoardTTLVoltage)(uiBoardIndex, uiVoltage);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetNumberOfModules(
    unsigned int uiBoardIndex,
    unsigned int& uiNumberOfModules)
{
    if (fp_adqGetNumberOfModules)
    {
        return (fp_adqGetNumberOfModules)(uiBoardIndex, uiNumberOfModules);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetBoardSynchronStartInfo(
	unsigned int uiBoardIndex,
	SADQBoardSynchronStartInfo& sBoardSynchronInfo)
{
	if (fp_adqGetBoardSynchronStartInfo)
	{
		return (fp_adqGetBoardSynchronStartInfo)(uiBoardIndex, sBoardSynchronInfo);
	}
	return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqConfigBoardSynchronStart(
	unsigned int uiBoardIndex, 
	unsigned int uiGroupIndex, 
	unsigned int uiModuleMap)
{
	if (fp_adqConfigBoardSynchronStart)
	{
		return (fp_adqConfigBoardSynchronStart)(uiBoardIndex, uiGroupIndex, uiModuleMap);
	}
	return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqBoardSynchronStart(
	unsigned int uiBoardIndex, 
	unsigned int uiGroupIndex)
{
	if (fp_adqBoardSynchronStart)
	{
		return (fp_ adqBoardSynchronStart)(uiBoardIndex, uiGroupIndex);
	}
	return ADQ_ERROR_FUNCTION_NOT_FOUND;
}


unsigned int adqGetModuleType(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int& uiModuleType)
{
    if (fp_adqGetModuleType)
    {
        return (fp_adqGetModuleType)(uiBoardIndex, uiModuleIndex, uiModuleType);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetModuleInfo(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    SADQGeneralModuleInfo & sModuleInfo,
    unsigned int uiBufferSize,
    unsigned char* pucBuffer,
    unsigned int& uiInfoSize)
{
    if (fp_adqGetModuleInfo)
    {
        return (fp_adqGetModuleInfo)(uiBoardIndex, uiModuleIndex, sModuleInfo, uiBufferSize, pucBuffer, uiInfoSize);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqResetModule(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex)
{
    if (fp_adqResetModule)
    {
        return (fp_adqResetModule)(uiBoardIndex, uiModuleIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetMaximumSampleFrequency(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiNumberOfChannels,
    double& dMaximumSampleFrequency)
{
    if (fp_adqGetMaximumSampleFrequency)
    {
        return (fp_adqGetMaximumSampleFrequency)(uiBoardIndex, uiModuleIndex, uiNumberOfChannels, dMaximumSampleFrequency);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqSetFrequency(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    double dNominalFrequency,
    double& dActualFrequency)
{
    if (fp_adqSetFrequency)
    {
        return (fp_adqSetFrequency)(uiBoardIndex, uiModuleIndex, dNominalFrequency, dActualFrequency);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetHWTriggerInfo(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    SADQHWTriggerInfo & sHWTriggerInfo)
{
    if (fp_adqGetHWTriggerInfo)
    {
        return (fp_adqGetHWTriggerInfo)(uiBoardIndex, uiModuleIndex, sHWTriggerInfo);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqEnableHWTrigger(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    SADQHWTriggerEnable & sHWTriggerEnable,
    bool bWaitForTrigger,
    unsigned int uiTimeoutMilliseconds)
{
    if (fp_adqEnableHWTrigger)
    {
        return (fp_adqEnableHWTrigger)(
            uiBoardIndex,
            uiModuleIndex,
            sHWTriggerEnable,
            bWaitForTrigger,
            uiTimeoutMilliseconds);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqDisableHWTrigger(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex)
{
    if (fp_adqDisableHWTrigger)
    {
        return (fp_adqDisableHWTrigger)(
            unsigned int uiBoardIndex,
            unsigned int uiModuleIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqReadSingle(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int& uiValue)
{
    if (fp_adqReadSingle)
    {
        return (fp_adqReadSingle)(uiBoardIndex, uiModuleIndex, uiValue);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqReadBuffer(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiNumberOfValuesRequired,
    unsigned int* puiValues,
    unsigned int& uiNumberOfValuesReturned)
{
    if (fp_adqReadBuffer)
    {
        return (fp_adqReadBuffer)(
            uiBoardIndex,
            uiModuleIndex,
            uiNumberOfValuesRequired,
            puiValues,
            uiNumberOfValuesReturned);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqReadContinuousStart(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiNotifyAfterValues,
    unsigned __int64 ui64StopAfterValues,
    ADQ_READ_CONTINUOUS_CALLBACK adqReadContinuousCallback,
    void* pvReadContinuousUserContext)
{
    if (fp_adqReadContinuousStart)
    {
        return (fp_adqReadContinuousStart)(
            uiBoardIndex,
            uiModuleIndex,
            uiNotifyAfterValues,
            ui64StopAfterValues,
            adqReadContinuousCallback,
            pvReadContinuousUserContext);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqReadContinuous(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiNumberOfValuesRequired,
    unsigned int* puiValues,
    bool bWaitForData,
    unsigned int& uiNumberOfValuesReturned)
{
    if (fp_adqReadContinuous)
    {
        return (fp_adqReadContinuous)(
            uiBoardIndex,
            uiModuleIndex,
            uiNumberOfValuesRequired,
            puiValues,
            bWaitForData,
            uiNumberOfValuesReturned);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqReadContinuousStatus(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    bool bWaitForIdle,
    unsigned int& uiNumberOfValuesAvailable,
    bool& bRunning)
{
    if (fp_adqReadContinuousStatus)
    {
        return (fp_adqReadContinuousStatus)(
            uiBoardIndex,
            uiModuleIndex,
            bWaitForIdle,
            uiNumberOfValuesAvailable,
            bRunning);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqWriteSingle(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiValue)
{
    if (fp_adqWriteSingle)
    {
        return (fp_adqWriteSingle)(uiBoardIndex, uiModuleIndex, uiValue);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqWriteBuffer(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiBufferSizeValues,
    unsigned int* puiValues,
    unsigned int uiRepeatBuffer,
    unsigned int& uiNumberOfValuesWritten)
{
    if (fp_adqWriteBuffer)
    {
        return (fp_adqWriteBuffer)(
            uiBoardIndex,
            uiModuleIndex,
            uiBufferSizeValues,
            puiValues,
            uiRepeatBuffer,
            uiNumberOfValuesWritten);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqWriteContinuousStart(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiBufferSizeValues,
    unsigned int* puiValues,
    unsigned int uiRepeatBuffer,
    bool bWaitForWrite,
    unsigned int uiNotifyAfterValues,
    unsigned int& uiNumberOfValuesWritten,
    ADQ_WRITE_CONTINUOUS_CALLBACK adqWriteContinuousCallback,
    void* pvWriteContinuousUserContext)
{
    if (fp_adqWriteContinuousStart)
    {
        return (fp_adqWriteContinuousStart)(
            uiBoardIndex,
            uiModuleIndex,
            uiBufferSizeValues,
            puiValues,
            uiRepeatBuffer,
            bWaitForWrite,
            uiNotifyAfterValues,
            uiNumberOfValuesWritten,
            adqWriteContinuousCallback,
            pvWriteContinuousUserContext);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqWriteContinuous(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiBufferSizeValues,
    unsigned int* puiValues,
    unsigned int uiRepeatBuffer,
    bool bWaitForWrite,
    unsigned int& uiNumberOfValuesWritten)
{
    if (fp_adqWriteContinuous)
    {
        return (fp_adqWriteContinuous)(
            uiBoardIndex,
            uiModuleIndex,
            uiBufferSizeValues,
            puiValues,
            uiRepeatBuffer,
            bWaitForWrite,
            uiNumberOfValuesWritten);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqWriteContinuousStatus(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    bool bWaitForIdle,
    unsigned int& uiNumberOfValuesAcceptable,
    bool& bRunning)
{
    if (fp_adqWriteContinuousStatus)
    {
        return (fp_adqWriteContinuousStatus)(
            uiBoardIndex,
            uiModuleIndex,
            bWaitForIdle,
            uiNumberOfValuesAcceptable,
            bRunning);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqStop(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex)
{
    if (fp_adqStop)
    {
        return (fp_adqStop)(uiBoardIndex, uiModuleIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetIRQInfo(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    SADQIRQInfo & sIRQInfo)
{
    if (fp_adqGetIRQInfo)
    {
        return (fp_adqGetIRQInfo)(uiBoardIndex, uiModuleIndex, sIRQInfo);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqEnableIRQ(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    SADQIRQEnable & sIRQEnable,
    ADQ_IRQ_CALLBACK adqIRQCallback,
    unsigned int uiSADQIRQStatusID,
    void* pvIRQUserContext)
{
    if (fp_adqEnableIRQ)
    {
        return (fp_adqEnableIRQ)(
            uiBoardIndex,
            uiModuleIndex,
            sIRQEnable,
            adqIRQCallback,
            uiSADQIRQStatusID,
            pvIRQUserContext);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqWaitIRQ(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    SADQIRQStatus & sIRQStatus,
    unsigned int uiTimeoutMilliseconds)
{
    if (fp_adqWaitIRQ)
    {
        return (fp_adqWaitIRQ)(uiBoardIndex, uiModuleIndex, sIRQStatus, uiTimeoutMilliseconds);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqGetIRQCount(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int& uiIRQCount)
{
    if (fp_adqGetIRQCount)
    {
        return (fp_adqGetIRQCount)(uiBoardIndex, uiModuleIndex, uiIRQCount);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqDisableIRQ(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex)
{
    if (fp_adqDisableIRQ)
    {
        return (fp_adqDisableIRQ)(uiBoardIndex, uiModuleIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqDIOGetDirection(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int& uiDirection)
{
    if (fp_adqDIOGetDirection)
    {
        return (fp_adqDIOGetDirection)(uiBoardIndex, uiModuleIndex, uiDirection);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqDIOSetDirection(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiDirection)
{
    if (fp_adqDIOSetDirection)
    {
        return (fp_adqDIOSetDirection)(uiBoardIndex, uiModuleIndex, uiDirection);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqDIOGetFilterPicoseconds(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned __int64& ui64FilterPicoseconds)
{
    if (fp_adqDIOGetFilterPicoseconds)
    {
        return (fp_adqDIOGetFilterPicoseconds)(uiBoardIndex, uiModuleIndex, ui64FilterPicoseconds);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqDIOSetFilterPicoseconds(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned __int64 ui64FilterPicoseconds)
{
    if (fp_adqDIOSetFilterPicoseconds)
    {
        return (fp_adqDIOSetFilterPicoseconds)(uiBoardIndex, uiModuleIndex, ui64FilterPicoseconds);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqCNTRConfig(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiClockSource,
    unsigned int uiCntrMode,
    unsigned int uiStartValue)
{
    if (fp_adqCNTRConfig)
    {
        return (fp_adqCNTRConfig)(
            uiBoardIndex,
            uiModuleIndex,
            uiClockSource,
            uiCntrMode,
            uiStartValue);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqCNTRConfigEx(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiCNTRConfigSize,
    unsigned char* pucCNTRConfig)
{
    if (fp_adqCNTRConfigEx)
    {
        return (fp_adqCNTRConfigEx)(
            uiBoardIndex,
            uiModuleIndex,
            uiCNTRConfigSize,
            pucCNTRConfig);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqCNTREnable(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex)
{
    if (fp_adqCNTREnable)
    {
        return (fp_adqCNTREnable)(
            uiBoardIndex,
            uiModuleIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqCNTRDisable(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex)
{
    if (fp_adqCNTRDisable)
    {
        return (fp_adqCNTRDisable)(
            uiBoardIndex,
            uiModuleIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAISetChannelAndRange(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiChannelIndex,
    unsigned int uiRangeIndex)
{
    if (fp_adqAISetChannelAndRange)
    {
        return (fp_adqAISetChannelAndRange)(
            uiBoardIndex,
            uiModuleIndex,
            uiChannelIndex,
            uiRangeIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAIGetChannelHardwareRange(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiChannelIndex,
    unsigned int& uiRangeIndex)
{
    if (fp_adqAIGetChannelHardwareRange)
    {
        return (fp_adqAIGetChannelHardwareRange)(
            uiBoardIndex,
            uiModuleIndex,
            uiChannelIndex,
            uiRangeIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAISetChannelList(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    SADQAIChannel * parrsChannels,
    unsigned int uiNumberOfChannels)
{
    if (fp_adqAISetChannelList)
    {
        return (fp_adqAISetChannelList)(
            uiBoardIndex,
            uiModuleIndex,
            parrsChannels,
            uiNumberOfChannels);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAISetChannelListAndFrequency(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    SADQAIChannel * parrsChannels,
    unsigned int uiNumberOfChannels,
    double dNominalFrequency,
    double& dActualFrequency)
{
    if (fp_adqAISetChannelListAndFrequency)
    {
        return (fp_adqAISetChannelListAndFrequency)(
            uiBoardIndex,
            uiModuleIndex,
            parrsChannels,
            uiNumberOfChannels,
            dNominalFrequency,
            dActualFrequency);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAIReadSingle(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiFrameLength,
    unsigned int* puiFrame)
{
    if (fp_adqAIReadSingle)
    {
        return (fp_adqAIReadSingle)(
            uiBoardIndex,
            uiModuleIndex,
            uiFrameLength,
            puiFrame);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAIReadBuffer(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiFrameLength,
    unsigned int uiNumberOfFramesRequired,
    unsigned int* puiFrames,
    unsigned int& uiNumberOfFramesReturned)
{
    if (fp_adqAIReadBuffer)
    {
        return (fp_adqAIReadBuffer)(
            uiBoardIndex,
            uiModuleIndex,
            uiFrameLength,
            uiNumberOfFramesRequired,
            puiFrames,
            uiNumberOfFramesReturned);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAIReadContinuousStart(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiNotifyAfterFrames,
    unsigned __int64 ui64StopAfterFrames,
    ADQ_AI_READ_CONTINUOUS_CALLBACK adqAIReadContinuousCallback,
    void* pvAIReadContinuousUserContext)
{
    if (fp_adqAIReadContinuousStart)
    {
        return (fp_adqAIReadContinuousStart)(
            uiBoardIndex,
            uiModuleIndex,
            uiNotifyAfterFrames,
            ui64StopAfterFrames,
            adqAIReadContinuousCallback,
            pvAIReadContinuousUserContext);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAIReadContinuous(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiFrameLength,
    unsigned int uiNumberOfFramesRequired,
    unsigned int* puiFrames,
    bool bWaitForData,
    unsigned int& uiNumberOfFramesReturned)
{
    if (fp_adqAIReadContinuous)
    {
        return (fp_adqAIReadContinuous)(
            uiBoardIndex,
            uiModuleIndex,
            uiFrameLength,
            uiNumberOfFramesRequired,
            puiFrames,
            bWaitForData,
            uiNumberOfFramesReturned);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAIReadContinuousStatus(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    bool bWaitForIdle,
    unsigned int& uiNumberOfFramesAvailable,
    bool& bRunning)
{
    if (fp_adqAIReadContinuousStatus)
    {
        return (fp_adqAIReadContinuousStatus)(
            uiBoardIndex,
            uiModuleIndex,
            bWaitForIdle,
            uiNumberOfFramesAvailable,
            bRunning);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAnalogGetSelectedCalibration(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int& uiCalibrationID)
{
    if (fp_adqAnalogGetSelectedCalibration)
    {
        return (fp_adqAnalogGetSelectedCalibration)(
            uiBoardIndex,
            uiModuleIndex,
            uiCalibrationID);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAnalogSelectCalibration(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiCalibrationID)
{
    if (fp_adqAnalogSelectCalibration)
    {
        return (fp_adqAnalogSelectCalibration)(
            uiBoardIndex,
            uiModuleIndex,
            uiCalibrationID);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAISetCalibrationZero(
	unsigned int uiBoardIndex, 
	unsigned int uiModuleIndex, 
	unsigned int uiChannelIndex, 
	unsigned int uiRangeIndex)
{
    if (fp_adqAISetCalibrationZero)
    {
        return (fp_adqAISetCalibrationZero)(
            uiBoardIndex,
            uiModuleIndex,
            uiChannelIndex, 
			uiRangeIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}
	
unsigned int adqAnalogGetNumberOfUserCalibrations(
	unsigned int uiBoardIndex, 
	unsigned int uiModuleIndex, 
	unsigned int& uiNumberOfUserCalibrations)
{
    if (fp_adqAnalogGetNumberOfUserCalibrations)
    {
        return (fp_adqAnalogGetNumberOfUserCalibrations)(
            uiBoardIndex,
            uiModuleIndex,
			uiNumberOfUserCalibrations);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAnalogSetTemporaryCalibration(
	unsigned int uiBoardIndex, 
	unsigned int uiModuleIndex, 
	unsigned int uiChannelIndex, 
	unsigned int uiRangeIndex, 
	double dNominalPhysicalValue1, 
	double dActualPhysicalValue1, 
	double dNominalPhysicalValue2, 
	double dActualPhysicalValue2)
{
    if (fp_adqAnalogSetTemporaryCalibration)
    {
        return (fp_adqAnalogSetTemporaryCalibration)(
            uiBoardIndex,
            uiModuleIndex,
			uiChannelIndex, 
			uiRangeIndex, 
			dNominalPhysicalValue1, 
			dActualPhysicalValue1, 
			dNominalPhysicalValue2, 
			dActualPhysicalValue2);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqAnalogGetCalibrationFactorAndConstant(
	unsigned int uiBoardIndex,
	unsigned int uiModuleIndex,
	unsigned int uiChannelIndex,
	unsigned int uiRangeIndex,
	unsigned int uiCalibrationID,
	double& dCalibrationFactor,
	double& dCalibrationConstant)
{
	if (fp_adqAnalogGetCalibrationFactorAndConstant)
	{
		return (fp_adqAnalogGetCalibrationFactorAndConstant)(
			uiBoardIndex,
			uiModuleIndex,
			uiChannelIndex,
			uiRangeIndex,
			uiCalibrationID,
			dCalibrationFactor,
			dCalibrationConstant);
	}
	return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqI2CSetSlaveAddress(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiSlaveAddress)
{
    if (fp_adqI2CSetSlaveAddress)
    {
        return (fp_adqI2CSetSlaveAddress)(
            uiBoardIndex,
            uiModuleIndex,
            uiSlaveAddress);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqI2CRead(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiNumberOfBytesRequired,
    unsigned char* pucData,
    unsigned int& uiNumberOfBytesReturned)
{
    if (fp_adqI2CRead)
    {
        return (fp_adqI2CRead)(
            uiBoardIndex,
            uiModuleIndex,
            uiNumberOfBytesRequired,
            pucData,
            uiNumberOfBytesReturned);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqI2CWrite(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiNumberOfBytesToWrite,
    unsigned char* pucData,
    unsigned int& uiNumberOfBytesWritten)
{
    if (fp_adqI2CWrite)
    {
        return (fp_adqI2CWrite)(
            uiBoardIndex,
            uiModuleIndex,
            uiNumberOfBytesToWrite,
            pucData,
            uiNumberOfBytesWritten);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqI2CWriteThenRead(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiNumberOfBytesToWrite,
    unsigned char* pucWriteData,
    unsigned int& uiNumberOfBytesWritten,
    unsigned int uiNumberOfBytesRequired,
    unsigned char* pucReadData,
    unsigned int& uiNumberOfBytesReturned)
{
    if (fp_adqI2CWriteThenRead)
    {
        return (fp_adqI2CWriteThenRead)(
            uiBoardIndex,
            uiModuleIndex,
            uiNumberOfBytesToWrite,
            pucWriteData,
            uiNumberOfBytesWritten,
            uiNumberOfBytesRequired,
            pucReadData,
            uiNumberOfBytesReturned);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqPWMGetMaximumFrequency(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    double& dMaximumFrequency)
{
    if (fp_adqPWMGetMaximumFrequency)
    {
        return (fp_adqPWMGetMaximumFrequency)(
            uiBoardIndex,
            uiModuleIndex,
            dMaximumFrequency);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqPWMConfig(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    double dNominalFrequency,
    double dNominalOnTime,
    bool bInvert,
    bool bHardwareTrigger,
    double& dActualFrequency,
    double& dActualOnTime)
{
    if (fp_adqPWMConfig)
    {
        return (fp_adqPWMConfig)(
            uiBoardIndex,
            uiModuleIndex,
            dNominalFrequency,
            dNominalOnTime,
            bInvert,
            bHardwareTrigger,
            dActualFrequency,
            dActualOnTime);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqPWMEnable(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    unsigned int uiTimeoutMilliseconds)
{
    if (fp_adqPWMEnable)
    {
        return (fp_adqPWMEnable)(
            uiBoardIndex,
            uiModuleIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqPWMDisable(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex)
{
    if (fp_adqPWMDisable)
    {
        return (fp_adqPWMDisable)(
            uiBoardIndex,
            uiModuleIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqFINRead(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    double& dFrequency,
    double& dOnTime,
    unsigned int uiTimeoutMilliseconds)
{
    if (fp_adqFINRead)
    {
        return (fp_adqFINRead)(
            uiBoardIndex,
            uiModuleIndex,
            dFrequency,
            dOnTime,
            uiTimeoutMilliseconds);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqI2SOSineConfig(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    double dNominalOutputFrequency,
    unsigned int uiSignalLeftPrecisionBits,
    bool bSignalLeftTwosComplement,
    double dSignalLeftSignalFrequency,
    double dSignalLeftAmplitude,
    unsigned int uiSignalRightPrecisionBits,
    bool bSignalRightTwosComplement,
    double dSignalRightSignalFrequency,
    double dSignalRightAmplitude,
    double& dActualOutputFrequency)
{
    if (fp_adqI2SOSineConfig)
    {
        return (fp_adqI2SOSineConfig)(
            uiBoardIndex,
            uiModuleIndex,
            dNominalOutputFrequency,
            uiSignalLeftPrecisionBits,
            bSignalLeftTwosComplement,
            dSignalLeftSignalFrequency,
            dSignalLeftAmplitude,
            uiSignalRightPrecisionBits,
            bSignalRightTwosComplement,
            dSignalRightSignalFrequency,
            dSignalRightAmplitude,
            dActualOutputFrequency);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqI2SOSineStart(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex)
{
    if (fp_adqI2SOSineStart)
    {
        return (fp_adqI2SOSineStart)(
            uiBoardIndex,
            uiModuleIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqI2SOSineModify(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex,
    double dSignalLeftSignalFrequency,
    double dSignalLeftAmplitude,
    double dSignalRightSignalFrequency,
    double dSignalRightAmplitude)
{
    if (fp_adqI2SOSineModify)
    {
        return (fp_adqI2SOSineModify)(
            uiBoardIndex,
            uiModuleIndex,
            dSignalLeftSignalFrequency,
            dSignalLeftAmplitude,
            dSignalRightSignalFrequency,
            dSignalRightAmplitude);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqI2SOSineStop(
    unsigned int uiBoardIndex,
    unsigned int uiModuleIndex)
{
    if (fp_adqI2SOSineStop)
    {
        return (fp_adqI2SOSineStop)(
            uiBoardIndex,
            uiModuleIndex);
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}

unsigned int adqClose(void)
{
    if (fp_adqClose)
    {
        return (fp_adqClose)();
    }
    return ADQ_ERROR_FUNCTION_NOT_FOUND;
}
